#include <afx.h>
#include "EPFF6Extract.h"
#include "OBBitmap.h"



unsigned long __declspec(dllexport) DecompressData(CFile *Fin, unsigned long nOffset, unsigned char *Dest, unsigned long FinalSize){
	unsigned char buf[100000] = { 0 };
	unsigned short size;

	Fin->Seek(nOffset, CFile::begin);
	Fin->Read(&size, 2);
	Fin->Seek(-2, CFile::current);
	Fin->Read(buf, size);

	return (DecompressData(buf, Dest, FinalSize));
}



unsigned long __declspec(dllexport) DecompressData(unsigned char *CompressedData, unsigned char *Dest, unsigned long FinalSize){
	unsigned char *buf;
	unsigned char buf2[2048] = { 0 };
	unsigned char n;
	unsigned char x;
	unsigned char b;
	unsigned short size;
	unsigned int w;
	unsigned int num;
	unsigned int i;
	unsigned long bpos;
	unsigned long bpos2;
	unsigned long nSizeCtr = 0;

	size = *((unsigned short*) CompressedData);
	size = (size - 2) & 0xFFFF;
	buf = &CompressedData[2];

	bpos = 0; 
	bpos2 = 2014;

	while(nSizeCtr < FinalSize && bpos < size){
		n = buf[bpos]; 
		bpos++;
		
		for(x = 0; x < 8; x++){
			if((n >> x) & 1){
				b = buf[bpos]; 
				bpos++;
				*(Dest++) = b;
				nSizeCtr++;
				buf2[bpos2&2047] = b; 
				bpos2++;
			}
			else{
				w = buf[bpos] + (buf[bpos + 1] << 8);
				bpos += 2;
				num = (w >> 11) + 3;
				w = w & 2047;
				
				for(i = 0; i < num; i++){
					b = buf2[(w + i) & 2047];
					*(Dest++) = b;
					nSizeCtr++;
					buf2[bpos2 & 2047] = b; 
					bpos2++;
					if(nSizeCtr >= FinalSize){
						i = num;
					}
				}
			}
			if(nSizeCtr >= FinalSize || bpos >= size){
				x = 8;
			}
		}
	}
	if(bpos != size){
		nSizeCtr = 0;
	}
	return nSizeCtr;
}



void __declspec(dllexport) WriteHexFile(unsigned char *RawData, char *sFileName, unsigned short nWidth, unsigned long nSize){
	unsigned int i;
	unsigned int j;
	FILE *Fout;
	
	Fout = fopen(sFileName, "w");
	for(i = 0; i < nSize; i += nWidth){
		for(j = 0; j < nWidth && j < nSize - i; j++){
			fprintf(Fout, "%02X", RawData[i + j]);
		}
		fprintf(Fout, "\n");
	}
	fclose(Fout);
}



void __declspec(dllexport) WriteOutMap(unsigned char *RawData, unsigned int width, unsigned int height, char *filename){
	OBBitmap LocMap;

    LocMap.SetDim(width, height);
	LocMap.SetPaletteGrey();
	for(unsigned int y = 0; y < height; y++){
		for(unsigned int x = 0; x < width; x++){
			LocMap.Data[(height - y - 1) * width + x] = RawData[y * width + x];
		}
	}
	LocMap.WriteOutBitmap(filename);
}
