// FF3Doc.h : interface of the CFF3Doc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_FF3DOC_H__F76E85AA_B089_11D3_BC2A_00E029364BE2__INCLUDED_)
#define AFX_FF3DOC_H__F76E85AA_B089_11D3_BC2A_00E029364BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include <afxwin.h>
#include <afxtempl.h>
#include "FF3Data.h"
#include "mylib.h"

using namespace std;

class CFF3Doc : public CDocument{
public:
	unsigned char *RomData;
	CFile *Fin;
	unsigned char m_bValid;
	unsigned long m_dwROMEnd;

	WorldData* worldData;
	unsigned char event[16384];

	CTypedPtrArray<CPtrArray, DialogueItem*> dialogue;
	unsigned char charWidths[128];

	Character characters[64];
	CharacterGraphic characterGraphic[40];
	unsigned char hpProgression[98];
	unsigned char mpProgression[98];

	Item items[256];
	Esper espers[27];
	Magic magic[256];
	BattleCommand battleCommands[32];
	ShopData shops[128];

	MonsterFormation monsterFormations[576];
	Monster monsters[384];
	MonsterTemplate monsterTemplates[13][6];
	int monsterTemplateCount[13];
	unsigned char monsterGraphics[0x38000];
	MonsterVisuals monsterVisuals[384];
	MonsterComposition monsterCompositions[176];
	unsigned short monsterPalettes[0x1800];
	unsigned char morphPackages[26][4];

	unsigned short variableFont[11 * 128];
	unsigned char fixedFont[16 * 128];

	unsigned short characterPalettes[128];		// 8 palettes, 16 words each
	unsigned short portraitPalettes[256];		// 16 palettes, 16 words each

	unsigned char MenuScreenGraphics[7168];
	unsigned short MenuScreenPalettes[128];
	unsigned short AirshipPaletteDaryl[16];

	CFF3Doc();
	void WriteOutMonsters();
	void Put8x8x4Tile(unsigned char *aTile, MonsterVisuals* pVis, int offset);
	void Put8x8x3Tile(unsigned char *aTile, MonsterVisuals* pVis, int offset);
	void WriteOutMonsterData();
	void WriteOutPortraits();
	void WriteOutCharacterData();
	void WriteOutMenuScreens();
	void WriteOutMiniMap();
	void WriteOutLocationTiles(unsigned char *LocationTiles, unsigned short *LocationPalette, unsigned char *LocationFormation);
	void WriteLocation(unsigned char *Data, unsigned int width, unsigned int height, unsigned short *Palette, char *filename);
	void WriteOutItemData();
	void WriteOutEsperData();
	void WriteOutEspers();
	void WriteLocPropData();
	void WriteLocStrings();
	void MakeNoCompression(byte* RawData, uint nLength, char* sFilename);
	void WriteBattleBG();


public:
	virtual void DeleteContents();
	virtual unsigned char OnOpenDocument(char* lpszPathName);

// Implementation
public:
	virtual ~CFF3Doc();
};

void TranslateString(unsigned char *String, char *sNewStr, unsigned char nStrLen);
void TranslateString(unsigned char *String, string sNewStr, unsigned char nStrLen);


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FF3DOC_H__F76E85AA_B089_11D3_BC2A_00E029364BE2__INCLUDED_)
